//+------------------------------------------------------------------+
//|                                       IndicatorCrosslinesCCI.mq4 |
//|                        Copyright 2012, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_width1 2
#property indicator_width2 2

extern   int      IndicatorID          = 1234567;
extern   int      Timeframe            = 0;
extern   int      limit                = 34;
extern   bool     showlabels           = false;
extern   int      period               = 8;
extern   int      applied_price        = 5;
extern   int      LineShift            = 1;
extern   color    resistanceColor      = Black;
extern   color    supportColor         = Black;
extern   int      Labelsize            = 8;
extern   int      Linewidth            = 2;
extern   bool     calculateonbarclose  = false;
extern   bool     showarrows           = true;

                                                                                                             //
         double   buyarrow[];
         double   sellarrow[];       
         int      periode;
         string   Symbolde;
      
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(2);
   SetIndexBuffer(0, buyarrow);
   SetIndexStyle(0, DRAW_ARROW, EMPTY);
   SetIndexArrow(0, 233);
   SetIndexBuffer(1, sellarrow);
   SetIndexStyle(1, DRAW_ARROW, EMPTY);
   SetIndexArrow(1, 234);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
     for (int i = ObjectsTotal()-1; i>=0; i--) 
    {
     string tmp = ObjectName(i);
     if (StringFind(tmp,IndicatorID+"Resistance") >= 0) ObjectDelete(tmp);
     if (StringFind(tmp,IndicatorID+"Support") >= 0) ObjectDelete(tmp);
    }
   return(0);
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted(),i,drawresend=0,drawsupend=0;
   double indicatorvalue[];   
   ArrayResize(indicatorvalue,limit);
   double reshigh=0;
   double suplow=0;
   bool calculateit=false;
   
   //----
   if(calculateonbarclose)
   {
      if(NewBar()||Period()!=periode||Symbol()!=Symbolde)
      {
         calculateit=true;
      }
      else
      calculateit=false;
   }
   else calculateit=true;


   if(calculateit)
   {
   periode=Period();
   Symbolde=Symbol();
      for(i=limit;i>=0;i--)
      {
         indicatorvalue[i]=iCCI(NULL,Timeframe,period,applied_price,iBarShift(NULL,Timeframe,iTime(NULL,0,i)));
         if(i<(limit))
         {
            if(indicatorvalue[i+1]>0&&indicatorvalue[i+0]<0)
            {
               drawresend=Resistbars(i+LineShift);
               if(ObjectFind(IndicatorID+"Resistance"+"CCI"+period+Time[i]+Timeframe)==-1)
               {
               DrawRes(drawresend,i);
               
   
               reshigh=iHigh(NULL,Timeframe,iBarShift(NULL,Timeframe,iTime(NULL,0,i+LineShift)));
               }
               else
               ObjectSet(IndicatorID+"Resistance"+"CCI"+period+Time[i]+Timeframe,OBJPROP_TIME2,iTime(NULL,0,drawresend));
               if(showarrows)
               sellarrow[i]=High[i]+0.4*iATR(NULL,0,14,i);
               else
               sellarrow[i]=EMPTY_VALUE;
   
               
            }
            else
            sellarrow[i]=EMPTY_VALUE;
            
            if(indicatorvalue[i+1]>0&&indicatorvalue[i+0]>0)
            {
               if(ObjectFind(IndicatorID+"Resistance"+"CCI"+period+Time[i]+Timeframe)!=-1)
               {            
                  ObjectDelete(IndicatorID+"Resistance"+"CCI"+period+Time[i]+Timeframe);
                  
                  ObjectDelete(IndicatorID+"Resistance"+"label"+"CCI"+period+Time[i]+Timeframe);
               }
            }
            
            if(showlabels&&(iBarShift(NULL,Timeframe,iTime(NULL,0,i))-iBarShift(NULL,Timeframe,iTime(NULL,0,drawresend)))>3)
            {
            if(ObjectFind(IndicatorID+"Resistance"+"CCI"+period+Time[i]+Timeframe)!=-1)
            {
               if(ObjectFind(IndicatorID+"Resistance"+"label"+"CCI"+period+Time[i]+Timeframe)==-1)
               {
               ObjectCreate(IndicatorID+"Resistance"+"label"+"CCI"+period+Time[i]+Timeframe,OBJ_TEXT,0,Time[drawresend+4],reshigh);
               ObjectSetText(IndicatorID+"Resistance"+"label"+"CCI"+period+Time[i]+Timeframe,"CCIRes"+"("+period+")"+"_"+Timeframe);
               ObjectSet(IndicatorID+"Resistance"+"label"+"CCI"+period+Time[i]+Timeframe,OBJPROP_COLOR,resistanceColor); 
               ObjectSet(IndicatorID+"Resistance"+"label"+"CCI"+period+Time[i]+Timeframe,OBJPROP_FONTSIZE,Labelsize);
               }
               else
               ObjectMove(IndicatorID+"Resistance"+"label"+"CCI"+period+Time[i]+Timeframe,1,Time[drawresend+4],reshigh);
            }         
            }
            if(indicatorvalue[i+1]<0&&indicatorvalue[i]>0)
            {
               drawsupend=Supportbars(i+LineShift);
               if(ObjectFind(IndicatorID+"Support"+"CCI"+period+Time[i]+Timeframe)==-1)
               {
               ObjectCreate(IndicatorID+"Support"+"CCI"+period+Time[i]+Timeframe,OBJ_TREND,0,iTime(NULL,Timeframe,iBarShift(NULL,Timeframe,iTime(NULL,0,i+LineShift))),iLow(NULL,Timeframe,iBarShift(NULL,Timeframe,iTime(NULL,0,i+LineShift))),iTime(NULL,0,drawsupend),iLow(NULL,Timeframe,iBarShift(NULL,Timeframe,iTime(NULL,0,i+LineShift))));
               ObjectSet(IndicatorID+"Support"+"CCI"+period+Time[i]+Timeframe,OBJPROP_RAY,true);
               ObjectSet(IndicatorID+"Support"+"CCI"+period+Time[i]+Timeframe,OBJPROP_COLOR,supportColor);
               ObjectSet(IndicatorID+"Support"+"CCI"+period+Time[i]+Timeframe,OBJPROP_WIDTH,Linewidth);
               suplow=iLow(NULL,Timeframe,iBarShift(NULL,Timeframe,iTime(NULL,0,i+LineShift)));
               }
               else
               ObjectSet(IndicatorID+"Support"+"CCI"+period+Time[i]+Timeframe,OBJPROP_TIME2,iTime(NULL,0,drawsupend));
               
               if(showarrows)            
               buyarrow[i]=Low[i]-0.2*iATR(NULL,0,14,i);
               else
               buyarrow[i]=EMPTY_VALUE;
               
   
               
            } 
            else
            buyarrow[i]=EMPTY_VALUE;
            if(indicatorvalue[i+1]<0&&indicatorvalue[i+0]<0)
            {
               if(ObjectFind(IndicatorID+"Support"+"CCI"+period+Time[i]+Timeframe)!=-1)
               {            
                  ObjectDelete(IndicatorID+"Support"+"CCI"+period+Time[i]+Timeframe);
                  ObjectDelete(IndicatorID+"Support"+"label"+"CCI"+period+Time[i]+Timeframe);
               }
            }   
            
            if(showlabels&&(iBarShift(NULL,Timeframe,iTime(NULL,0,i))-iBarShift(NULL,Timeframe,iTime(NULL,0,drawsupend)))>3)
               {
                           if(ObjectFind(IndicatorID+"Support"+"CCI"+period+Time[i]+Timeframe)!=-1)
               {
                  if(ObjectFind(IndicatorID+"Support"+"label"+"CCI"+period+Time[i]+Timeframe)==-1)
                  {
                  ObjectCreate(IndicatorID+"Support"+"label"+"CCI"+period+Time[i]+Timeframe,OBJ_TEXT,0,Time[drawsupend+4],suplow);
                  ObjectSetText(IndicatorID+"Support"+"label"+"CCI"+period+Time[i]+Timeframe,"CCISup"+"("+period+")"+"_"+Timeframe);
                  ObjectSet(IndicatorID+"Support"+"label"+"CCI"+period+Time[i]+Timeframe,OBJPROP_COLOR,supportColor);
                  ObjectSet(IndicatorID+"Support"+"label"+"CCI"+period+Time[i]+Timeframe,OBJPROP_FONTSIZE,Labelsize);
                  }
                  else
                  ObjectMove(IndicatorID+"Support"+"label"+"CCI"+period+Time[i]+Timeframe,1,Time[drawsupend+4],suplow);
               }     
            }
   
                  
   
            
            
         }
         
      }
               
   }   
//----
   return(0);
  }
//+------------------------------------------------------------------+

int Resistbars(int Shift)
 {
     int rbars=0;
     for(int xi=Shift-1;xi>=0;xi--)
     {
         if(iHigh(NULL,Timeframe,iBarShift(NULL,Timeframe,iTime(NULL,0,Shift)))<High[xi])
         {
         rbars=xi; xi=0;
         }
         else
         rbars=xi;
     }           
     return(rbars);
 }
 
int Supportbars(int Shift)
 {
     int rbars=0;
     for(int xi=Shift-1;xi>=0;xi--)
     {
         if(iLow(NULL,Timeframe,iBarShift(NULL,Timeframe,iTime(NULL,0,Shift)))>Low[xi])
         {
         rbars=xi; xi=0;
         }
         else
         rbars=xi;
     }           
     
     return(rbars);
 }
 bool NewBar()

{

   static datetime lastbar;

   datetime curbar = Time[0];

   if(lastbar!=curbar)

   {

      lastbar=curbar;

      return (true);

   }

   else return(false);

}
  
  
  
void DrawRes(int drawiresend,int resi)
{
            
            ObjectCreate(IndicatorID+"Resistance"+"CCI"+period+Time[resi]+Timeframe,OBJ_TREND,0,iTime(NULL,Timeframe,iBarShift(NULL,Timeframe,iTime(NULL,0,resi+LineShift))),iHigh(NULL,Timeframe,iBarShift(NULL,Timeframe,iTime(NULL,0,resi+LineShift))),iTime(NULL,0,drawiresend),iHigh(NULL,Timeframe,iBarShift(NULL,Timeframe,iTime(NULL,0,resi+LineShift))));
            ObjectSet(IndicatorID+"Resistance"+"CCI"+period+Time[resi]+Timeframe,OBJPROP_RAY,true);
            ObjectSet(IndicatorID+"Resistance"+"CCI"+period+Time[resi]+Timeframe,OBJPROP_COLOR,resistanceColor);
            ObjectSet(IndicatorID+"Resistance"+"CCI"+period+Time[resi]+Timeframe,OBJPROP_WIDTH,Linewidth);
            return;
}
  
  